| API Docs for SAX and DOM |

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# SAXParser Class Reference

This class implements the SAX 'Parser' interface and should be used by applications wishing to parse the XML files using SAX. More...

`#include <SAXParser.hpp>`

Inheritance diagram for SAXParser

[legend]
Collaboration diagram for SAXParser:

[legend]
List of all members.

## Public Types

enum | ValSchemes { Val_Never, Val_Always, Val_Auto }
| ValScheme enum used in setValidationScheme Val_Never: Do not report validation errors. More...

## Public Methods

Constructors and Destructor
| SAXParser (XMLValidator *const valToAdopt=0)
| Constructor with an instance of validator class to use for validation. More...
| ~SAXParser ()
| Destructor.
Getter methods
DocumentHandler* | getDocumentHandler ()
| This method returns the installed document handler. More...
const DocumentHandler* | getDocumentHandler ()const
| This method returns the installed document handler. More...
EntityResolver* | getEntityResolver ()
| This method returns the installed entity resolver. More...
const EntityResolver* | getEntityResolver ()const
| This method returns the installed entity resolver. More...
ErrorHandler* | getErrorHandler ()
| This method returns the installed error handler. More...
const ErrorHandler* | getErrorHandler ()const
| This method returns the installed error handler. More...
const XMLValidator& | getValidator ()const
| This method returns a reference to the parser's installed validator. More...
ValSchemes | getValidationScheme ()const
| This method returns an enumerated value that indicates the current validation scheme set on this parser. More...
bool | getDoSchema ()const
| Get the 'do schema' flag. More...
bool | getValidationSchemaFullChecking ()const
| Get the 'full schema constraint checking' flag. More...
int | getErrorCount ()const
| Get error count from the last parse operation. More...
bool | getDoNamespaces ()const
| This method returns the state of the parser's namespace handling capability. More...
bool | getExitOnFirstFatalError ()const
| This method returns the state of the parser's exit-on-First-Fatal-Error flag. More...
bool | getValidationConstraintFatal ()const
| This method returns the state of the parser's validation-constraint-fatal flag. More...
XMLCh* | getExternalSchemaLocation ()const
| Get the set of Namespace/SchemaLocation that is specified externaly. More...
XMLCh* | getExternalNoNamespaceSchemaLocation ()const
| Get the noNamespace SchemaLocation that is specified externaly. More...
bool | getLoadExternalDTD ()const
| Get the 'Loading External DTD' flag. More...
bool | isCachingGrammarFromParse ()const
| Get the 'Grammar caching' flag. More...
bool | isUsingCachedGrammarInParse ()const
| Get the 'Use cached grammar' flag. More...
Grammar* | getGrammar (const XMLCh *const nameSpaceKey)
| Retrieve the grammar that is associated with the specified namespace key. More...
Grammar* | getRootGrammar ()
| Retrieve the grammar where the root element is declared. More...
const XMLCh* | getURIText (unsigned int uriId)
| Returns the string corresponding to a URI id from the URI string pool. More...
Setter methods
void | setDoNamespaces (const bool newState)
| This method allows users to enable or disable the parser's namespace processing. More...
void | setValidationScheme (const ValSchemes newScheme)
| This method allows users to set the validation scheme to be used by this parser. More...
void | setDoSchema (const bool newState)
| Set the 'schema support' flag. More...
void | setValidationSchemaFullChecking (const bool schemaFullChecking)
| This method allows the user to turn full Schema constraint checking on/off. More...
void | setExitOnFirstFatalError (const bool newState)
| This method allows users to set the parser's behaviour when it encounters the first fatal error. More...
void | setValidationConstraintFatal (const bool newState)
| This method allows users to set the parser's behaviour when it encounters a validtion constraint error. More...
void | setExternalSchemaLocation (const XMLCh *const schemaLocation)
| This method allows the user to specify a list of schemas to use. More...
void | setExternalSchemaLocation (const char *const schemaLocation)
| This method is same as setExternalSchemaLocation(const XMLCh* const). More...
void | setExternalNoNamespaceSchemaLocation (const XMLCh *const noNamespaceSchemaLocation)
| This method allows the user to specify the no target namespace XML Schema Location externally. More...
void | setExternalNoNamespaceSchemaLocation (const char *const noNamespaceSchemaLocation)
| This method is same as setExternalNoNamespaceSchemaLocation(const XMLCh* const). More...
void | setLoadExternalDTD (const bool newState)
| Set the 'Loading External DTD' flag. More...
void | cacheGrammarFromParse (const bool newState)
| Set the 'Grammar caching' flag. More...
void | useCachedGrammarInParse (const bool newState)
| Set the 'Use cached grammar' flag. More...
Advanced document handler list maintenance methods
void | installAdvDocHandler (XMLDocumentHandler *const toInstall)
| This method installs the specified 'advanced' document callback handler, thereby allowing the user to customize the processing, if they choose to do so. More...
bool | removeAdvDocHandler (XMLDocumentHandler *const toRemove)
| This method removes the 'advanced' document handler callback from the underlying parser scanner. More...
Progressive scan methods
bool | parseFirst (const XMLCh *const systemId,XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseFirst (const char *const systemId,XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseFirst (const InputSource &source,XMLPScanToken &toFill)
| Begin a progressive parse operation. More...
bool | parseNext (XMLPScanToken &token)
| Continue a progressive parse operation. More...
void | parseReset (XMLPScanToken &token)
| Reset the parser after a progressive parse. More...
Implementation of Grammar preparsing interface's.
Grammar* | loadGrammar (const InputSource &source,const short grammarType,const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via an input source object. More...
Grammar* | loadGrammar (const XMLCh *const systemId,const short grammarType,const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL. More...
Grammar* | loadGrammar (const char *const systemId,const short grammarType,const bool toCache=false)
| Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL. More...
void | resetCachedGrammarPool ()
| This method allows the user to reset the pool of cached grammars.
Implementation of SAX 1.0 Parser interface's.
virtual void | parse (const InputSource &source)
| This method invokes the parsing process on the XML file specified by the InputSource parameter. More...
virtual void | parse (const XMLCh *const systemId)
| This method invokes the parsing process on the XML file specified by the Unicode string parameter 'systemId'. More...
virtual void | parse (const char *const systemId)
| This method invokes the parsing process on the XML file specified by the native char* string parameter 'systemId'. More...
virtual void | setDocumentHandler (DocumentHandler *const handler)
| This method installs the user specified SAX Document Handler callback function on parser. More...
virtual void | setDTDHandler (DTDHandler *const handler)
| This method installs the user specified DTD handler on the parser. More...
virtual void | setErrorHandler (ErrorHandler *const handler)
| This method installs the user specified error handler on the parser. More...
virtual void | setEntityResolver (EntityResolver *const resolver)
| This method installs the user specified entity resolver on the parser. More...
Implementation of the XMLDocumentHandler Interface.
virtual void | docCharacters (const XMLCh *const chars,const unsigned int length,const bool cdataSection)
| This method is used to report all the characters scanned by the parser. More...
virtual void | docComment (const XMLCh *const comment)
| This method is used to report any comments scanned by the parser. More...
virtual void | docPI (const XMLCh *const target,const XMLCh *const data)
| This method is used to report any PI scanned by the parser. More...
virtual void | endDocument ()
| This method is used to indicate the end of root element was just scanned by the parser. More...
virtual void | endElement (const XMLElementDecl &elemDecl,const unsigned int urlId,const bool isRoot,const XMLCh *const elemPrefix)
| This method is used to indicate the end tag of an element. More...
virtual void | endEntityReference (const XMLEntityDecl &entDecl)
| This method is used to indicate that an end of an entity reference was just scanned. More...
virtual void | ignorableWhitespace (const XMLCh *const chars,const unsigned int length,const bool cdataSection)
| This method is used to report all the whitespace characters, which are determined to be 'ignorable'. More...
virtual void | resetDocument ()
| This method allows the user installed Document Handler and any advanced callback handlers to 'reset' themselves.
virtual void | startDocument ()
| This method is used to report the start of the parsing process. More...
virtual void | startElement (const XMLElementDecl &elemDecl,const unsigned int urlId,const XMLCh *const elemPrefix,const RefVectorOf< XMLAttr > &attrList,const unsigned int attrCount,const bool isEmpty,const bool isRoot)
| This method is used to report the start of an element. More...
virtual void | startEntityReference (const XMLEntityDecl &entDecl)
| This method is used to indicate the start of an entity reference. More...
virtual void | XMLDecl (const XMLCh *const versionStr,const XMLCh *const encodingStr,const XMLCh *const standaloneStr,const XMLCh *const actualEncodingStr)
| This method is used to report the XML decl scanned by the parser. More...
Implementation of the XMLErrorReporter Interface.
virtual void | error (const unsigned int errCode,const XMLCh *const msgDomain,const XMLErrorReporter::ErrTypes errType,const XMLCh *const errorText,const XMLCh *const systemId,const XMLCh *const publicId,const XMLSSize_t lineNum,const XMLSSize_t colNum)
| This method is used to report back errors found while parsing the XML file. More...
virtual void | resetErrors ()
| This method allows the user installed Error Handler callback to 'reset' itself. More...
Implementation of the XMLEntityHandler Interface.
virtual void | endInputSource (const InputSource &inputSource)
| This method is used to indicate the end of parsing of an external entity file. More...
virtual bool | expandSystemId (const XMLCh *const systemId,XMLBuffer &toFill)
| This method allows an installed XMLEntityHandler to further process any system id's of enternal entities encountered in the XML file being parsed, such as redirection etc. More...
virtual void | resetEntities ()
| This method allows the installed XMLEntityHandler to reset itself. More...
virtual InputSource* | resolveEntity (const XMLCh *const publicId,const XMLCh *const systemId,const XMLCh *const baseURI=0)
| This method allows a user installed entity handler to further process any pointers to external entities. More...
virtual void | startInputSource (const InputSource &inputSource)
| This method is used to indicate the start of parsing an external entity file. More...
Implementation of the deprecated DocTypeHandler Interface
virtual void | attDef (const DTDElementDecl &elemDecl,const DTDAttDef &attDef,const bool ignore)
| This method is used to report an attribute definition. More...
virtual void | doctypeComment (const XMLCh *const comment)
| This method is used to report a comment occurring within the DTD. More...
virtual void | doctypeDecl (const DTDElementDecl &elemDecl,const XMLCh *const publicId,const XMLCh *const systemId,const bool hasIntSubset,const bool hasExtSubset=false)
| This method is used to report the DOCTYPE declaration. More...
virtual void | doctypePI (const XMLCh *const target,const XMLCh *const data)
| This method is used to report any PI declarations occurring inside the DTD definition block. More...
virtual void | doctypeWhitespace (const XMLCh *const chars,const unsigned int length)
| This method is used to report any whitespaces occurring inside the DTD definition block. More...
virtual void | elementDecl (const DTDElementDecl &decl,const bool isIgnored)
| This method is used to report an element declarations successfully scanned by the parser. More...
virtual void | endAttList (const DTDElementDecl &elemDecl)
| This method is used to report the end of an attribute list declaration for an element. More...
virtual void | endIntSubset ()
| This method is used to report the end of the internal subset. More...
virtual void | endExtSubset ()
| This method is used to report the end of the external subset. More...
virtual void | entityDecl (const DTDEntityDecl &entityDecl,const bool isPEDecl,const bool isIgnored)
| This method is used to report any entity declarations. More...
virtual void | resetDocType ()
| This method allows the user installed DTD handler to reset itself.
virtual void | notationDecl (const XMLNotationDecl &notDecl,const bool isIgnored)
| This method is used to report any notation declarations. More...
virtual void | startAttList (const DTDElementDecl &elemDecl)
| This method is used to indicate the start of an element's attribute list declaration. More...
virtual void | startIntSubset ()
| This method is used indicate the start of the internal subset. More...
virtual void | startExtSubset ()
| This method is used indicate the start of the external subset. More...
virtual void | TextDecl (const XMLCh *const versionStr,const XMLCh *const encodingStr)
| This method is used to report the TextDecl. More...
Deprecated Methods
bool | getDoValidation ()const
| This method returns the state of the parser's validation handling flag which controls whether validation checks are enforced or not. More...
void | setDoValidation (const bool newState)
| This method allows users to enable or disable the parser's validation checks. More...

## Protected Methods

const XMLScanner& | getScanner ()const
| This method returns a reference to the underlying scanner object. More...

## Detailed Description

This class implements the SAX 'Parser' interface and should be used by applications wishing to parse the XML files using SAX.

It allows the client program to install SAX handlers for event callbacks.

It can be used to instantiate a validating or non-validating parser, by setting a member flag.

## Member Enumeration Documentation

enum SAXParser::ValSchemes

ValScheme enum used in setValidationScheme Val_Never: Do not report validation errors.

Val_Always: The parser will always report validation errors. Val_Auto: The parser will report validation errors only if a grammar is specified.

See also:
  setValidationScheme

Enumeration values:

  Val_Never |
  Val_Always |
  Val_Auto |

## Constructor & Destructor Documentation

SAXParser::SAXParser ( | XMLValidator *const valToAdopt = 0 )

Constructor with an instance of validator class to use for validation.

Parameters:

  valToAdopt | Pointer to the validator instance to use. The parser is responsible for freeing the memory.

SAXParser::~SAXParser ( | )

| Destructor.

## Member Function Documentation

void SAXParser::TextDecl ( | const XMLCh *const versionStr,
| const XMLCh *const encodingStr )`[virtual]`

This method is used to report the TextDecl.

Refer to the XML specification for the syntax of a TextDecl.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  versionStr | A const pointer to a Unicode string representing the version number of the 'version' clause.
  encodingStr | A const pointer to a Unicode string representing the encoding name of the 'encoding' clause.

void SAXParser::XMLDecl ( | const XMLCh *const versionStr,
| const XMLCh *const encodingStr,
| const XMLCh *const standaloneStr,
| const XMLCh *const actualEncodingStr )`[virtual]`

This method is used to report the XML decl scanned by the parser.

Refer to the XML specification to see the meaning of parameters.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  versionStr | A const pointer to a Unicode string representing version string value.
  encodingStr | A const pointer to a Unicode string representing the encoding string value.
  standaloneStr | A const pointer to a Unicode string representing the standalone string value.
  actualEncodingStr | A const pointer to a Unicode string representing the actual encoding string value.

Reimplemented from XMLDocumentHandler.

void SAXParser::attDef ( | const DTDElementDecl & elemDecl,
| const DTDAttDef & attDef,
| const bool ignore )`[virtual]`

This method is used to report an attribute definition.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  elemDecl | A const reference to the object containing information about the element whose attribute definition was just parsed.
  attDef | A const reference to the object containing information attribute definition.
  ignore | The flag indicating whether this attribute definition was ignored by the parser or not.

void SAXParser::cacheGrammarFromParse ( | const bool newState )

Set the 'Grammar caching' flag.

This method allows users to enable or disable caching of grammar when parsing XML documents. When set to true, the parser will cache the resulting grammar for use in subsequent parses.

If the flag is set to true, the 'Use cached grammar' flag will also be set to true.

The parser's default state is: false.

Parameters:

  newState | The value specifying whether we should cache grammars or not.

See also:
  isCachingGrammarFromParse , useCachedGrammarInParse

void SAXParser::docCharacters ( | const XMLCh *const chars,
| const unsigned int length,
| const bool cdataSection )`[virtual]`

This method is used to report all the characters scanned by the parser.

The driver will invoke the 'characters' method of the user installed SAX Document Handler.

If any advanced callback handlers are installed, the corresponding 'docCharacters' method will also be invoked.

Parameters:

  chars | A const pointer to a Unicode string representing the character data.
  length | The length of the Unicode string returned in 'chars'.
  cdataSection | A flag indicating if the characters represent content from the CDATA section.

See also:
  DocumentHandler::characters

Reimplemented from XMLDocumentHandler.

void SAXParser::docComment ( | const XMLCh *const comment )`[virtual]`

This method is used to report any comments scanned by the parser.

This method is a no-op unless, unless an advanced callback handler is installed, in which case the corresponding 'docComment' method is invoked.

Parameters:

  comment | A const pointer to a null terminated Unicode string representing the comment text.

Reimplemented from XMLDocumentHandler.

void SAXParser::docPI ( | const XMLCh *const target,
| const XMLCh *const data )`[virtual]`

This method is used to report any PI scanned by the parser.

Any PI's occurring before any 'content' are not reported to any SAX handler as per the specification. However, all PI's within content are reported via the SAX Document Handler's 'processingInstruction' method.

If any advanced callback handlers are installed, the corresponding 'docPI' method will be invoked.

Parameters:

  target | A const pointer to a Unicode string representing the target of the PI declaration.
  data | A const pointer to a Unicode string representing the data of the PI declaration. See the PI production rule in the XML specification for details.

See also:
  DocumentHandler::processingInstruction

Reimplemented from XMLDocumentHandler.

void SAXParser::doctypeComment ( | const XMLCh *const comment )`[virtual]`

This method is used to report a comment occurring within the DTD.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  comment | A const pointer to a Unicode string representing the text of the comment just parsed.

void SAXParser::doctypeDecl ( | const DTDElementDecl & elemDecl,
| const XMLCh *const publicId,
| const XMLCh *const systemId,
| const bool hasIntSubset,
| const bool hasExtSubset = false )`[virtual]`

This method is used to report the DOCTYPE declaration.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  elemDecl | A const reference to the object containing information about the root element definition declaration of the XML document being parsed.
  publicId | A const pointer to a Unicode string representing the public id of the DTD file.
  systemId | A const pointer to a Unicode string representing the system id of the DTD file.
  hasIntSubset | A flag indicating if this XML file contains any internal subset.
  hasExtSubset | A flag indicating if this XML file contains any external subset. Default is false.

void SAXParser::doctypePI ( | const XMLCh *const target,
| const XMLCh *const data )`[virtual]`

This method is used to report any PI declarations occurring inside the DTD definition block.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  target | A const pointer to a Unicode string representing the target of the PI declaration.
  data | A const pointer to a Unicode string representing the data of the PI declaration. See the PI production rule in the XML specification for details.

void SAXParser::doctypeWhitespace ( | const XMLCh *const chars,
| const unsigned int length )`[virtual]`

This method is used to report any whitespaces occurring inside the DTD definition block.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  chars | A const pointer to a Unicode string representing the whitespace characters.
  length | The length of the whitespace Unicode string.

void SAXParser::elementDecl ( | const DTDElementDecl & decl,
| const bool isIgnored )`[virtual]`

This method is used to report an element declarations successfully scanned by the parser.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  decl | A const reference to the object containing element declaration information.
  isIgnored | The flag indicating whether this definition was ignored by the parser or not.

void SAXParser::endAttList ( | const DTDElementDecl & elemDecl )`[virtual]`

This method is used to report the end of an attribute list declaration for an element.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  elemDecl | A const reference to the object containing element declaration information.

void SAXParser::endDocument ( | )`[virtual]`

This method is used to indicate the end of root element was just scanned by the parser.

Corresponding 'endDocument' method of the user installed SAX Document Handler will also be invoked.

In addition, if any advanced callback handlers are installed, the corresponding 'endDocument' method is invoked.

See also:
  DocumentHandler::endDocument

Reimplemented from XMLDocumentHandler.

void SAXParser::endElement ( | const XMLElementDecl & elemDecl,
| const unsigned int urlId,
| const bool isRoot,
| const XMLCh *const elemPrefix )`[virtual]`

This method is used to indicate the end tag of an element.

The driver will invoke the corresponding 'endElement' method of the SAX Document Handler interface.

If any advanced callback handlers are installed, the corresponding 'endElement' method is also invoked.

Parameters:

  elemDecl | A const reference to the object containing element declaration information.
  urlId | An id referring to the namespace prefix, if namespaces setting is switched on.
  isRoot | A flag indicating whether this element was the root element.
  elemPrefix | A const pointer to a Unicode string containing the namespace prefix for this element. Applicable only when namespace processing is enabled.

See also:
  DocumentHandler::endElement

Reimplemented from XMLDocumentHandler.

void SAXParser::endEntityReference ( | const XMLEntityDecl & entDecl )`[virtual]`

This method is used to indicate that an end of an entity reference was just scanned.

If any advanced callback handlers are installed, the corresponding 'endEnityReference' method is invoked.

Parameters:

  entDecl | A const reference to the object containing the entity declaration information.

Reimplemented from XMLDocumentHandler.

void SAXParser::endExtSubset ( | )`[virtual]`

| This method is used to report the end of the external subset. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

void SAXParser::endInputSource ( | const InputSource & inputSource )`[virtual]`

This method is used to indicate the end of parsing of an external entity file.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  inputSource | A const reference to the InputSource object which points to the XML file being parsed.

See also:
  InputSource

Reimplemented from XMLEntityHandler.

void SAXParser::endIntSubset ( | )`[virtual]`

| This method is used to report the end of the internal subset. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

void SAXParser::entityDecl ( | const DTDEntityDecl & entityDecl,
| const bool isPEDecl,
| const bool isIgnored )`[virtual]`

This method is used to report any entity declarations.

For unparsed entities, this driver will invoke the SAX DTDHandler::unparsedEntityDecl callback.

Parameters:

  entityDecl | A const reference to the object containing the entity declaration information.
  isPEDecl | The flag indicating whether this was a parameter entity declaration or not.
  isIgnored | The flag indicating whether this definition was ignored by the parser or not.

See also:
  DTDHandler::unparsedEntityDecl

void SAXParser::error ( | const unsigned int errCode,
| const XMLCh *const msgDomain,
| const XMLErrorReporter::ErrTypes errType,
| const XMLCh *const errorText,
| const XMLCh *const systemId,
| const XMLCh *const publicId,
| const XMLSSize_t lineNum,
| const XMLSSize_t colNum )`[virtual]`

This method is used to report back errors found while parsing the XML file.

The driver will call the corresponding user installed SAX Error Handler methods: 'fatal', 'error', 'warning' depending on the severity of the error. This classification is defined by the XML specification.

Parameters:

  errCode | An integer code for the error.
  msgDomain | A const pointer to an Unicode string representing the message domain to use.
  errType | An enumeration classifying the severity of the error.
  errorText | A const pointer to an Unicode string representing the text of the error message.
  systemId | A const pointer to an Unicode string representing the system id of the XML file where this error was discovered.
  publicId | A const pointer to an Unicode string representing the public id of the XML file where this error was discovered.
  lineNum | The line number where the error occurred.
  colNum | The column number where the error occurred.

See also:
  ErrorHandler

bool SAXParser::expandSystemId ( | const XMLCh * const,
| XMLBuffer & toFill )`[virtual]`

This method allows an installed XMLEntityHandler to further process any system id's of enternal entities encountered in the XML file being parsed, such as redirection etc.

<font color="FF0000">This method always returns 'false' for this SAX driver implementation.</font>

Parameters:

  systemId | A const pointer to an Unicode string representing the system id scanned by the parser.
  toFill | A pointer to a buffer in which the application processed system id is stored.

Returns:
  'true', if any processing is done, 'false' otherwise.

Reimplemented from XMLEntityHandler.

bool SAXParser::getDoNamespaces ( | ) const

This method returns the state of the parser's namespace handling capability.

Returns:
  true, if the parser is currently configured to understand namespaces, false otherwise.

See also:
  setDoNamespaces

bool SAXParser::getDoSchema ( | ) const

Get the 'do schema' flag.

This method returns the state of the parser's schema processing flag.

Returns:
  true, if the parser is currently configured to understand schema, false otherwise.

See also:
  setDoSchema

bool SAXParser::getDoValidation ( | ) const

This method returns the state of the parser's validation handling flag which controls whether validation checks are enforced or not.

Returns:
  true, if the parser is currently configured to do validation, false otherwise.

See also:
  setDoValidation

const DocumentHandler * SAXParser::getDocumentHandler ( | ) const

This method returns the installed document handler.

Suitable only for 'rvalue' usages.

Returns:
  A const pointer to the installed document handler object.

DocumentHandler * SAXParser::getDocumentHandler ( | )

This method returns the installed document handler.

Suitable for 'lvalue' usages.

Returns:
  The pointer to the installed document handler object.

const EntityResolver * SAXParser::getEntityResolver ( | ) const

This method returns the installed entity resolver.

Suitable for 'rvalue' usages.

Returns:
  A const pointer to the installed entity resolver object.

EntityResolver * SAXParser::getEntityResolver ( | )

This method returns the installed entity resolver.

Suitable for 'lvalue' usages.

Returns:
  The pointer to the installed entity resolver object.

int SAXParser::getErrorCount ( | ) const

Get error count from the last parse operation.

This method returns the error count from the last parse operation. Note that this count is actually stored in the scanner, so this method simply returns what the scanner reports.

Returns:
  number of errors encountered during the latest parse operation.

const ErrorHandler * SAXParser::getErrorHandler ( | ) const

This method returns the installed error handler.

Suitable for 'rvalue' usages.

Returns:
  A const pointer to the installed error handler object.

ErrorHandler * SAXParser::getErrorHandler ( | )

This method returns the installed error handler.

Suitable for 'lvalue' usages.

Returns:
  The pointer to the installed error handler object.

bool SAXParser::getExitOnFirstFatalError ( | ) const

This method returns the state of the parser's exit-on-First-Fatal-Error flag.

Returns:
  true, if the parser is currently configured to exit on the first fatal error, false otherwise.

See also:
  setExitOnFirstFatalError

XMLCh * SAXParser::getExternalNoNamespaceSchemaLocation ( | ) const

Get the noNamespace SchemaLocation that is specified externaly.

This method returns the no target namespace XML Schema Location that was specified using setExternalNoNamespaceSchemaLocation.

The parser owns the returned string, and the memory allocated for the returned string will be destroyed when the parser is deleted.

To ensure assessiblity of the returned information after the parser is deleted, callers need to copy and store the returned information somewhere else.

Returns:
  a pointer to the no target namespace Schema Location that was specified externally. The pointer spans the same life-time as the parser. A null pointer is returned if nothing was specified externally.

See also:
  setExternalNoNamespaceSchemaLocation(const XMLCh* const)

XMLCh * SAXParser::getExternalSchemaLocation ( | ) const

Get the set of Namespace/SchemaLocation that is specified externaly.

This method returns the list of Namespace/SchemaLocation that was specified using setExternalSchemaLocation.

The parser owns the returned string, and the memory allocated for the returned string will be destroyed when the parser is deleted.

To ensure assessiblity of the returned information after the parser is deleted, callers need to copy and store the returned information somewhere else.

Returns:
  a pointer to the list of Namespace/SchemaLocation that was specified externally. The pointer spans the same life-time as the parser. A null pointer is returned if nothing was specified externally.

See also:
  setExternalSchemaLocation(const XMLCh* const)

Grammar * SAXParser::getGrammar ( | const XMLCh *const nameSpaceKey )

Retrieve the grammar that is associated with the specified namespace key.

Parameters:

  nameSpaceKey | Namespace key

Returns:
  Grammar associated with the Namespace key.

bool SAXParser::getLoadExternalDTD ( | ) const

Get the 'Loading External DTD' flag.

This method returns the state of the parser's loading external DTD flag.

Returns:
  false, if the parser is currently configured to ignore external DTD completely, true otherwise.

See also:
  setLoadExternalDTD , getValidationScheme

Grammar * SAXParser::getRootGrammar ( | )

Retrieve the grammar where the root element is declared.

Returns:
  Grammar where root element declared

const XMLScanner & SAXParser::getScanner ( | ) const`[protected]`

This method returns a reference to the underlying scanner object.

It allows read only access to data maintained in the scanner.

Returns:
  A const reference to the underlying scanner object.

const XMLCh * SAXParser::getURIText ( | unsigned int uriId )

Returns the string corresponding to a URI id from the URI string pool.

Parameters:

  uriId | id of the string in the URI string pool.

Returns:
  URI string corresponding to the URI id.

bool SAXParser::getValidationConstraintFatal ( | ) const

This method returns the state of the parser's validation-constraint-fatal flag.

Returns:
  true, if the parser is currently configured to set validation constraint errors as fatal, false otherwise.

See also:
  setValidationContraintFatal

bool SAXParser::getValidationSchemaFullChecking ( | ) const

Get the 'full schema constraint checking' flag.

This method returns the state of the parser's full schema constraint checking flag.

Returns:
  true, if the parser is currently configured to have full schema constraint checking, false otherwise.

See also:
  setValidationSchemaFullChecking

ValSchemes SAXParser::getValidationScheme ( | ) const

This method returns an enumerated value that indicates the current validation scheme set on this parser.

Returns:
  The ValSchemes value current set on this parser.

See also:
  setValidationScheme

const XMLValidator & SAXParser::getValidator ( | ) const

This method returns a reference to the parser's installed validator.

Returns:
  A const reference to the installed validator object.

void SAXParser::ignorableWhitespace ( | const XMLCh *const chars,
| const unsigned int length,
| const bool cdataSection )`[virtual]`

This method is used to report all the whitespace characters, which are determined to be 'ignorable'.

This distinction between characters is only made, if validation is enabled. Corresponding 'ignorableWhitespace' method of the user installed SAX Document Handler interface is called.

Any whitespace before content is not reported to the SAX Document Handler method, as per the SAX specification. However, if any advanced callback handlers are installed, the corresponding 'ignorableWhitespace' method is invoked.

Parameters:

  chars | A const pointer to a Unicode string representing the ignorable whitespace character data.
  length | The length of the Unicode string 'chars'.
  cdataSection | A flag indicating if the characters represent content from the CDATA section.

See also:
  DocumentHandler::ignorableWhitespace

Reimplemented from XMLDocumentHandler.

void SAXParser::installAdvDocHandler ( | XMLDocumentHandler *const toInstall )

This method installs the specified 'advanced' document callback handler, thereby allowing the user to customize the processing, if they choose to do so.

Any number of advanced callback handlers maybe installed.

The methods in the advanced callback interface represent Xerces-C extensions. There is no specification for this interface.

Parameters:

  toInstall | A pointer to the users advanced callback handler.

See also:
  removeAdvDocHandler

bool SAXParser::isCachingGrammarFromParse ( | ) const

Get the 'Grammar caching' flag.

This method returns the state of the parser's grammar caching when parsing an XML document.

Returns:
  true, if the parser is currently configured to cache grammars, false otherwise.

See also:
  cacheGrammarFromParse

bool SAXParser::isUsingCachedGrammarInParse ( | ) const

Get the 'Use cached grammar' flag.

This method returns the state of the parser's use of cached grammar when parsing an XML document.

Returns:
  true, if the parser is currently configured to use cached grammars, false otherwise.

See also:
  useCachedGrammarInParse

Grammar * SAXParser::loadGrammar ( | const char *const systemId,
| const short grammarType,
| const bool toCache = false )

Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL.

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  systemId | A const char pointer to a native string which contains the path to the XML grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

Grammar * SAXParser::loadGrammar ( | const XMLCh *const systemId,
| const short grammarType,
| const bool toCache = false )

Preparse schema grammar (XML Schema, DTD, etc.) via a file path or URL.

This method invokes the preparsing process on a schema grammar XML file specified by the file path parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  systemId | A const XMLCh pointer to the Unicode string which contains the path to the XML grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

Grammar * SAXParser::loadGrammar ( | const InputSource & source,
| const short grammarType,
| const bool toCache = false )

Preparse schema grammar (XML Schema, DTD, etc.) via an input source object.

This method invokes the preparsing process on a schema grammar XML file specified by the SAX InputSource parameter. If the 'toCache' flag is enabled, the parser will cache the grammars for re-use. If a grammar key is found in the pool, no caching of any grammar will take place.

"Experimental - subject to change"

Parameters:

  source | A const reference to the SAX InputSource object which points to the schema grammar file to be preparsed.
  grammarType | The grammar type (Schema or DTD).
  toCache | If `true`, we cache the preparsed grammar, otherwise, no chaching. Default is `false`.

Returns:
  The preparsed schema grammar object (SchemaGrammar or DTDGrammar). That grammar object is owned by the parser.

Exceptions:

  SAXException | Any SAX exception, possibly wrapping another exception.
  XMLException | An exception from the parser or client handler code.
  DOMException | A DOM exception as per DOM spec.

See also:
  InputSource::InputSource

void SAXParser::notationDecl ( | const XMLNotationDecl & notDecl,
| const bool isIgnored )`[virtual]`

This method is used to report any notation declarations.

If there is a user installed DTDHandler, then the driver will invoke the SAX DTDHandler::notationDecl callback.

Parameters:

  notDecl | A const reference to the object containing the notation declaration information.
  isIgnored | The flag indicating whether this definition was ignored by the parser or not.

See also:
  DTDHandler::notationDecl

void SAXParser::parse ( | const char *const systemId )`[virtual]`

This method invokes the parsing process on the XML file specified by the native char* string parameter 'systemId'.

Parameters:

  systemId | A const char pointer to a native string which contains the path to the XML file to be parsed.

Reimplemented from Parser.

void SAXParser::parse ( | const XMLCh *const systemId )`[virtual]`

This method invokes the parsing process on the XML file specified by the Unicode string parameter 'systemId'.

Parameters:

  systemId | A const XMLCh pointer to the Unicode string which contains the path to the XML file to be parsed.

See also:
  Parser::parse(XMLCh*)

Reimplemented from Parser.

void SAXParser::parse ( | const InputSource & source )`[virtual]`

This method invokes the parsing process on the XML file specified by the InputSource parameter.

Parameters:

  source | A const reference to the InputSource object which points to the XML file to be parsed.

See also:
  Parser::parse(InputSource)

Reimplemented from Parser.

bool SAXParser::parseFirst ( | const InputSource & source,
| XMLPScanToken & toFill )

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  source | A const reference to the InputSource object which points to the XML file to be parsed.
  toFill | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not parse the prolog.

See also:
  parseNext , parseFirst(XMLCh*,...) , parseFirst(char*,...)

bool SAXParser::parseFirst ( | const char *const systemId,
| XMLPScanToken & toFill )

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  systemId | A pointer to a regular native string represting the path to the XML file to be parsed.
  toFill | A token maintaing state information to maintain internal consIstency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not parse the prolog.

See also:
  parseNext , parseFirst(XMLCh*,...) , parseFirst(InputSource&,...)

bool SAXParser::parseFirst ( | const XMLCh *const systemId,
| XMLPScanToken & toFill )

Begin a progressive parse operation.

This method is used to start a progressive parse on a XML file. To continue parsing, subsequent calls must be to the parseNext method.

It scans through the prolog and returns a token to be used on subsequent scanNext() calls. If the return value is true, then the token is legal and ready for further use. If it returns false, then the scan of the prolog failed and the token is not going to work on subsequent scanNext() calls.

Parameters:

  systemId | A pointer to a Unicode string represting the path to the XML file to be parsed.
  toFill | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the prolog. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could parse the prolog (which means the token will not be valid.)

See also:
  parseNext , parseFirst(char*,...) , parseFirst(InputSource&,...)

bool SAXParser::parseNext ( | XMLPScanToken & token )

Continue a progressive parse operation.

This method is used to continue with progressive parsing of XML files started by a call to 'parseFirst' method.

It parses the XML file and stops as soon as it comes across a XML token (as defined in the XML specification). Relevant callback handlers are invoked as required by the SAX specification.

Parameters:

  token | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

Returns:
  'true', if successful in parsing the next XML token. It indicates the user can go ahead with parsing the rest of the file. It returns 'false' to indicate that the parser could not find next token as per the XML specification production rule.

See also:
  parseFirst(XMLCh*,...) , parseFirst(char*,...) , parseFirst(InputSource&,...)

void SAXParser::parseReset ( | XMLPScanToken & token )

Reset the parser after a progressive parse.

If a progressive parse loop exits before the end of the document is reached, the parser has no way of knowing this. So it will leave open any files or sockets or memory buffers that were in use at the time that the parse loop exited.

The next parse operation will cause these open files and such to be closed, but the next parse operation might occur at some unknown future point. To avoid this problem, you should reset the parser if you exit the loop early.

If you exited because of an error, then this cleanup will be done for you. Its only when you exit the file prematurely of your own accord, because you've found what you wanted in the file most likely.

Parameters:

  token | A token maintaing state information to maintain internal consistency between invocation of 'parseNext' calls.

bool SAXParser::removeAdvDocHandler ( | XMLDocumentHandler *const toRemove )

This method removes the 'advanced' document handler callback from the underlying parser scanner.

If no handler is installed, advanced callbacks are not invoked by the scanner.

Parameters:

  toRemove | A pointer to the advanced callback handler which should be removed.

See also:
  installAdvDocHandler

void SAXParser::resetCachedGrammarPool ( | )

| This method allows the user to reset the pool of cached grammars.

void SAXParser::resetDocType ( | )`[virtual]`

| This method allows the user installed DTD handler to reset itself.

void SAXParser::resetDocument ( | )`[virtual]`

| This method allows the user installed Document Handler and any advanced callback handlers to 'reset' themselves. Reimplemented from XMLDocumentHandler.

void SAXParser::resetEntities ( | )`[virtual]`

| This method allows the installed XMLEntityHandler to reset itself. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font> Reimplemented from XMLEntityHandler.

void SAXParser::resetErrors ( | )`[virtual]`

| This method allows the user installed Error Handler callback to 'reset' itself. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font> Reimplemented from XMLErrorReporter.

InputSource * SAXParser::resolveEntity ( | const XMLCh *const publicId,
| const XMLCh *const systemId,
| const XMLCh *const baseURI = 0 )`[virtual]`

This method allows a user installed entity handler to further process any pointers to external entities.

The applications can implement 'redirection' via this callback. The driver should call the SAX EntityHandler 'resolveEntity' method.

Parameters:

  publicId | A const pointer to a Unicode string representing the public id of the entity just parsed.
  systemId | A const pointer to a Unicode string representing the system id of the entity just parsed.
  baseURI | A const pointer to a Unicode string representing the base URI of the entity just parsed, or `null` if there is no base URI.

Returns:
  The value returned by the SAX resolveEntity method or NULL otherwise to indicate no processing was done. The returned InputSource is owned by the parser which is responsible to clean up the memory.

See also:
  EntityResolver , XMLEntityHandler

Reimplemented from XMLEntityHandler.

void SAXParser::setDTDHandler ( | DTDHandler *const handler )`[virtual]`

This method installs the user specified DTD handler on the parser.

Parameters:

  handler | A pointer to the DTD handler to be called when the parser comes across 'DTD' events as per the SAX specification.

See also:
  Parser::setDTDHandler

Reimplemented from Parser.

void SAXParser::setDoNamespaces ( | const bool newState )

This method allows users to enable or disable the parser's namespace processing.

When set to true, parser starts enforcing all the constraints / rules specified by the NameSpace specification.

The parser's default state is: false.

Parameters:

  newState | The value specifying whether NameSpace rules should be enforced or not.

See also:
  getDoNamespaces

void SAXParser::setDoSchema ( | const bool newState )

Set the 'schema support' flag.

This method allows users to enable or disable the parser's schema processing. When set to false, parser will not process any schema found.

The parser's default state is: false.

Note: If set to true, namespace processing must also be turned on.

Parameters:

  newState | The value specifying whether schema support should be enforced or not.

See also:
  getDoSchema

void SAXParser::setDoValidation ( | const bool newState )

This method allows users to enable or disable the parser's validation checks.

By default, the parser does not to any validation. The default value is false.

Parameters:

  newState | The value specifying whether the parser should do validity checks or not against the DTD in the input XML document.

See also:
  getDoValidation

void SAXParser::setDocumentHandler ( | DocumentHandler *const handler )`[virtual]`

This method installs the user specified SAX Document Handler callback function on parser.

Parameters:

  handler | A pointer to the document handler to be called when the parser comes across 'document' events as per the SAX specification.

See also:
  Parser::parse(char*)

Reimplemented from Parser.

void SAXParser::setEntityResolver ( | EntityResolver *const resolver )`[virtual]`

This method installs the user specified entity resolver on the parser.

It allows applications to trap and redirect calls to external entities.

Parameters:

  resolver | A pointer to the entity resolver to be called when the parser comes across references to entities in the XML file.

See also:
  Parser::setEntityResolver

Reimplemented from Parser.

void SAXParser::setErrorHandler ( | ErrorHandler *const handler )`[virtual]`

This method installs the user specified error handler on the parser.

Parameters:

  handler | A pointer to the error handler to be called when the parser comes across 'error' events as per the SAX specification.

See also:
  Parser::setErrorHandler

Reimplemented from Parser.

void SAXParser::setExitOnFirstFatalError ( | const bool newState )

This method allows users to set the parser's behaviour when it encounters the first fatal error.

If set to true, the parser will exit at the first fatal error. If false, then it will report the error and continue processing.

The default value is 'true' and the parser exits on the first fatal error.

Parameters:

  newState | The value specifying whether the parser should continue or exit when it encounters the first fatal error.

See also:
  getExitOnFirstFatalError

void SAXParser::setExternalNoNamespaceSchemaLocation ( | const char *const noNamespaceSchemaLocation )

This method is same as setExternalNoNamespaceSchemaLocation(const XMLCh* const).

It takes native char string as parameter

Parameters:

  noNamespaceSchemaLocation | the XML Schema Location with no target namespace

See also:
  setExternalNoNamespaceSchemaLocation(const XMLCh* const)

void SAXParser::setExternalNoNamespaceSchemaLocation ( | const XMLCh * const )

This method allows the user to specify the no target namespace XML Schema Location externally.

If specified, the instance document's noNamespaceSchemaLocation attribute will be effectively ignored.

If this method is called more than once, only the last one takes effect.

The syntax is the same as for the noNamespaceSchemaLocation attribute that may occur in an instance document: e.g."file_name.xsd".

Parameters:

  noNamespaceSchemaLocation | the XML Schema Location with no target namespace

See also:
  getExternalNoNamespaceSchemaLocation

void SAXParser::setExternalSchemaLocation ( | const char *const schemaLocation )

This method is same as setExternalSchemaLocation(const XMLCh* const).

It takes native char string as parameter

Parameters:

  schemaLocation | the list of schemas to use

See also:
  setExternalSchemaLocation(const XMLCh* const)

void SAXParser::setExternalSchemaLocation ( | const XMLCh * const )

This method allows the user to specify a list of schemas to use.

If the targetNamespace of a schema specified using this method matches the targetNamespace of a schema occuring in the instance document in the schemaLocation attribute, or if the targetNamespace matches the namespace attribute of the "import" element, the schema specified by the user using this method will be used (i.e., the schemaLocation attribute in the instance document or on the "import" element will be effectively ignored).

If this method is called more than once, only the last one takes effect.

The syntax is the same as for schemaLocation attributes in instance documents: e.g, "http://www.example.com file_name.xsd". The user can specify more than one XML Schema in the list.

Parameters:

  schemaLocation | the list of schemas to use

See also:
  getExternalSchemaLocation

void SAXParser::setLoadExternalDTD ( | const bool newState )

Set the 'Loading External DTD' flag.

This method allows users to enable or disable the loading of external DTD. When set to false, the parser will ignore any external DTD completely if the validationScheme is set to Val_Never.

The parser's default state is: true.

This flag is ignored if the validationScheme is set to Val_Always or Val_Auto.

Parameters:

  newState | The value specifying whether external DTD should be loaded or not.

See also:
  getLoadExternalDTD , setValidationScheme

void SAXParser::setValidationConstraintFatal ( | const bool newState )

This method allows users to set the parser's behaviour when it encounters a validtion constraint error.

If set to true, and the the parser will treat validation error as fatal and will exit depends on the state of "getExitOnFirstFatalError". If false, then it will report the error and continue processing.

Note: setting this true does not mean the validation error will be printed with the word "Fatal Error". It is still printed as "Error", but the parser will exit if "setExitOnFirstFatalError" is set to true.

The default value is 'false'.

Parameters:

  newState | If true, the parser will exit if "setExitOnFirstFatalError" is set to true.

See also:
  getValidationConstraintFatal , setExitOnFirstFatalError

void SAXParser::setValidationSchemaFullChecking ( | const bool schemaFullChecking )

This method allows the user to turn full Schema constraint checking on/off.

Only takes effect if Schema validation is enabled. If turned off, partial constraint checking is done.

Full schema constraint checking includes those checking that may be time-consuming or memory intensive. Currently, particle unique attribution constraint checking and particle derivation resriction checking are controlled by this option.

The parser's default state is: false.

Parameters:

  schemaFullChecking | True to turn on full schema constraint checking.

See also:
  getValidationSchemaFullChecking

void SAXParser::setValidationScheme ( | const ValSchemes newScheme )

This method allows users to set the validation scheme to be used by this parser.

The value is one of the ValSchemes enumerated values defined by this class:

Val_Never - turn off validation
Val_Always - turn on validation
Val_Auto - turn on validation if any internal/external DTD subset have been seen

The parser's default state is: Val_Auto.

Parameters:

  newScheme | The new validation scheme to use.

See also:
  getValidationScheme

void SAXParser::startAttList ( | const DTDElementDecl & elemDecl )`[virtual]`

This method is used to indicate the start of an element's attribute list declaration.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  elemDecl | A const reference to the object containing element declaration information.

void SAXParser::startDocument ( | )`[virtual]`

This method is used to report the start of the parsing process.

The corresponding user installed SAX Document Handler's method 'startDocument' is invoked.

If any advanced callback handlers are installed, then the corresponding 'startDocument' method is also called.

See also:
  DocumentHandler::startDocument

Reimplemented from XMLDocumentHandler.

void SAXParser::startElement ( | const XMLElementDecl & elemDecl,
| const unsigned int urlId,
| const XMLCh *const elemPrefix,
| const RefVectorOf< XMLAttr > & attrList,
| const unsigned int attrCount,
| const bool isEmpty,
| const bool isRoot )`[virtual]`

This method is used to report the start of an element.

It is called at the end of the element, by which time all attributes specified are also parsed. The corresponding user installed SAX Document Handler's method 'startElement' is invoked.

If any advanced callback handlers are installed, then the corresponding 'startElement' method is also called.

Parameters:

  elemDecl | A const reference to the object containing element declaration information.
  urlId | An id referring to the namespace prefix, if namespaces setting is switched on.
  elemPrefix | A const pointer to a Unicode string containing the namespace prefix for this element. Applicable only when namespace processing is enabled.
  attrList | A const reference to the object containing the list of attributes just scanned for this element.
  attrCount | A count of number of attributes in the list specified by the parameter 'attrList'.
  isEmpty | A flag indicating whether this is an empty element or not.
  isRoot | A flag indicating whether this element was the root element.

See also:
  DocumentHandler::startElement

Reimplemented from XMLDocumentHandler.

void SAXParser::startEntityReference ( | const XMLEntityDecl & entDecl )`[virtual]`

This method is used to indicate the start of an entity reference.

If any advanced callback handlers are installed, the corresponding 'endEnityReference' method is invoked.

Parameters:

  entDecl | A const reference to the object containing the entity declaration information.

Reimplemented from XMLDocumentHandler.

void SAXParser::startExtSubset ( | )`[virtual]`

| This method is used indicate the start of the external subset. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

void SAXParser::startInputSource ( | const InputSource & inputSource )`[virtual]`

This method is used to indicate the start of parsing an external entity file.

<font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

Parameters:

  inputSource | A const reference to the InputSource object which points to the external entity being parsed.

Reimplemented from XMLEntityHandler.

void SAXParser::startIntSubset ( | )`[virtual]`

| This method is used indicate the start of the internal subset. <font color="FF0000">This method is a no-op for this SAX driver implementation.</font>

void SAXParser::useCachedGrammarInParse ( | const bool newState )

Set the 'Use cached grammar' flag.

This method allows users to enable or disable the use of cached grammars. When set to true, the parser will use the cached grammar, instead of building the grammar from scratch, to validate XML documents.

If the 'Grammar caching' flag is set to true, this mehod ignore the value passed in.

The parser's default state is: false.

Parameters:

  newState | The value specifying whether we should use the cached grammar or not.

See also:
  isUsingCachedGrammarInParse , cacheGrammarFromParse

The documentation for this class was generated from the following file:

- SAXParser.hpp

Copyright © 2000 The Apache Software Foundation. All Rights Reserved.